searchNodes=[{"type":"module","title":"Ethereumex","doc":"Elixir JSON-RPC client for the Ethereum blockchain. Check out the documentation here . Installation Add :ethereumex to your list of dependencies in mix.exs : def deps do [ { :ethereumex , &quot;~&gt; 0.10&quot; } ] end Ensure :ethereumex is started before your application: def application do [ applications : [ :ethereumex ] ] end Configuration In config/config.exs , add Ethereum protocol host params to your config file config :ethereumex , url : &quot;http://localhost:8545&quot; You can also configure the HTTP request timeout for requests sent to the Ethereum JSON-RPC (you can also overwrite this configuration in opts used when calling the client). config :ethereumex , http_options : [ pool_timeout : 5000 , receive_timeout : 15_000 ] , http_headers : [ { &quot;Content-Type&quot; , &quot;application/json&quot; } ] :pool_timeout - This timeout is applied when we check out a connection from the pool. Default value is 5_000 . :receive_timeout - The maximum time to wait for a response before returning an error. Default value is 15_000 If you want to use IPC you will need to set a few things in your config. First, specify the :client_type : config :ethereumex , client_type : :ipc This will resolve to :http by default. Second, specify the :ipc_path : config :ethereumex , ipc_path : &quot;/path/to/ipc&quot; If you want to count the number of RPC calls per RPC method or overall, you can attach yourself to executed telemetry events. There are two events you can attach yourself to: [:ethereumex] # has RPC method name in metadata Emitted event: {:event, [:ethereumex], %{counter: 1}, %{method_name: &quot;method_name&quot;}} or more granular [:ethereumex, &lt;rpc_method&gt;] # %{} metadata Emitted event: {:event, [:ethereumex, :method_name_as_atom], %{counter: 1}, %{}} Each event caries a single ticker that you can pass into your counters (like Statix.increment/2 ). Be sure to add :telemetry as project dependency. The IPC client type mode opens a pool of connection workers (default is 5 and 2, respectively). You can configure the pool size. config :ethereumex , ipc_worker_size : 5 , ipc_max_worker_overflow : 2 , ipc_request_timeout : 60_000 Test Download parity and initialize the password file $ make setup Run parity $ make run Run tests $ make test Usage Available methods: web3_clientVersion web3_sha3 net_version net_peerCount net_listening eth_protocolVersion eth_syncing eth_coinbase eth_mining eth_hashrate eth_gasPrice eth_accounts eth_blockNumber eth_getBalance eth_getStorageAt eth_getTransactionCount eth_getBlockTransactionCountByHash eth_getBlockTransactionCountByNumber eth_getUncleCountByBlockHash eth_getUncleCountByBlockNumber eth_getCode eth_sign eth_sendTransaction eth_sendRawTransaction eth_call eth_estimateGas eth_getBlockByHash eth_getBlockByNumber eth_getTransactionByHash eth_getTransactionByBlockHashAndIndex eth_getTransactionByBlockNumberAndIndex eth_getTransactionReceipt eth_getUncleByBlockHashAndIndex eth_getUncleByBlockNumberAndIndex eth_getCompilers eth_compileLLL eth_compileSolidity eth_compileSerpent eth_newFilter eth_newBlockFilter eth_newPendingTransactionFilter eth_uninstallFilter eth_getFilterChanges eth_getFilterLogs eth_getLogs eth_getProof eth_getWork eth_submitWork eth_submitHashrate db_putString db_getString db_putHex db_getHex shh_post shh_version shh_newIdentity shh_hasIdentity shh_newGroup shh_addToGroup shh_newFilter shh_uninstallFilter shh_getFilterChanges shh_getMessages IpcClient You can follow along with any of these examples using IPC by replacing HttpClient with IpcClient . Examples iex&gt; Ethereumex.HttpClient . web3_client_version { :ok , &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot; } # Using the url option will overwrite the configuration iex&gt; Ethereumex.HttpClient . web3_client_version ( url : &quot;http://localhost:8545&quot; ) { :ok , &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot; } iex&gt; Ethereumex.HttpClient . web3_sha3 ( &quot;wrong_param&quot; ) { :error , %{ &quot;code&quot; =&gt; - 32602 , &quot;message&quot; =&gt; &quot;Invalid params: invalid format.&quot; } } iex&gt; Ethereumex.HttpClient . eth_get_balance ( &quot;0x407d73d8a49eeb85d32cf465507dd71d507100c1&quot; ) { :ok , &quot;0x0&quot; } Note that all method names are snakecases, so, for example, shh_getMessages method has corresponding Ethereumex.HttpClient.shh_get_messages/1 method. Signatures can be found in Ethereumex.Client.Behaviour. There are more examples in tests. eth_call example - Read only smart contract calls In order to call a smart contract using the JSON-RPC interface you need to properly hash the data attribute (this will need to include the contract method signature along with arguments if any). You can do this manually or use a hex package like ABI to parse your smart contract interface or encode individual calls. defp deps do [ ... { :ethereumex , &quot;~&gt; 0.9&quot; } , { :ex_abi , &quot;~&gt; 0.5&quot; } ... ] end Now load the ABI and pass the method signature. Note that the address needs to be converted to bytes: address = &quot;0xF742d4cE7713c54dD701AA9e92101aC42D63F895&quot; |&gt; String . slice ( 2 .. - 1 ) |&gt; Base . decode16! ( case : :mixed ) contract_address = &quot;0xC28980830dD8b9c68a45384f5489ccdAF19D53cC&quot; abi_encoded_data = ABI . encode ( &quot;balanceOf(address)&quot; , [ address ] ) |&gt; Base . encode16 ( case : :lower ) Now you can use eth_call to execute this smart contract command: balance_bytes = Ethereumex.HttpClient . eth_call ( %{ data : &quot;0x&quot; &lt;&gt; abi_encoded_data , to : contract_address } ) To convert the balance into an integer: balance_bytes |&gt; String . slice ( 2 .. - 1 ) |&gt; Base . decode16! ( case : :lower ) |&gt; TypeDecoder . decode_raw ( [ { :uint , 256 } ] ) |&gt; List . first Custom requests Many Ethereum protocol implementations support additional JSON-RPC API methods. To use them, you should call Ethereumex.HttpClient.request/3 method. For example, let's call parity's personal_listAccounts method. iex&gt; Ethereumex.HttpClient . request ( &quot;personal_listAccounts&quot; , [ ] , [ ] ) { :ok , [ &quot;0x71cf0b576a95c347078ec2339303d13024a26910&quot; , &quot;0x7c12323a4fff6df1a25d38319d5692982f48ec2e&quot; ] } Batch requests To send batch requests use Ethereumex.HttpClient.batch_request/1 or Ethereumex.HttpClient.batch_request/2 method. requests = [ { :web3_client_version , [ ] } , { :net_version , [ ] } , { :web3_sha3 , [ &quot;0x68656c6c6f20776f726c64&quot; ] } ] Ethereumex.HttpClient . batch_request ( requests ) { :ok , [ { :ok , &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot; } , { :ok , &quot;42&quot; } , { :ok , &quot;0x47173285a8d7341e5e972fc677286384f802f8ef42a5ec5f03bbfa254cb01fad&quot; } ] }","ref":"Ethereumex.html"},{"type":"module","title":"Ethereumex.Application","doc":"Configures and starts the :ethereumex OTP application","ref":"Ethereumex.Application.html"},{"type":"function","title":"Ethereumex.Application.start/2","doc":"Callback implementation for Application.start/2 .","ref":"Ethereumex.Application.html#start/2"},{"type":"module","title":"Ethereumex.Client.BaseClient","doc":"The Base Client exposes the Ethereum Client RPC functionality. We use a macro so that exposed functions can be used in different behaviours (HTTP or IPC).","ref":"Ethereumex.Client.BaseClient.html"},{"type":"module","title":"Ethereumex.Counter","doc":"An application wide RPC2Ethereum client request counter.","ref":"Ethereumex.Counter.html"},{"type":"function","title":"Ethereumex.Counter.get/1","doc":"","ref":"Ethereumex.Counter.html#get/1"},{"type":"function","title":"Ethereumex.Counter.increment/2","doc":"","ref":"Ethereumex.Counter.html#increment/2"},{"type":"function","title":"Ethereumex.Counter.increment/3","doc":"","ref":"Ethereumex.Counter.html#increment/3"},{"type":"function","title":"Ethereumex.Counter.setup/0","doc":"","ref":"Ethereumex.Counter.html#setup/0"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - 0.10.5 - 2022-09-06","doc":"Update deps ( https://github.com/mana-ethereum/ethereumex/pull/153 )","ref":"changelog.html#0-10-5-2022-09-06"},{"type":"extras","title":"Changelog - 0.10.4 - 2022-12-07","doc":"Update finch to 0.14 ( https://github.com/mana-ethereum/ethereumex/pull/141 )","ref":"changelog.html#0-10-4-2022-12-07"},{"type":"extras","title":"Changelog - 0.10.3 - 2022-09-15","doc":"Update jason to 1.4 ( https://github.com/mana-ethereum/ethereumex/pull/137 )","ref":"changelog.html#0-10-3-2022-09-15"},{"type":"extras","title":"Changelog - 0.10.2 - 2022-08-02","doc":"Fix typespec in HttpClient ( https://github.com/mana-ethereum/ethereumex/pull/134 )","ref":"changelog.html#0-10-2-2022-08-02"},{"type":"extras","title":"Changelog - 0.10.1 - 2022-07-29","doc":"Add option to not format batch requests ( https://github.com/mana-ethereum/ethereumex/pull/131 )","ref":"changelog.html#0-10-1-2022-07-29"},{"type":"extras","title":"Changelog - 0.10.0 - 2022-05-10","doc":"Add EIP1559 support for eth_maxPriorityFeePerGas and eth_feeHistory ( https://github.com/mana-ethereum/ethereumex/pull/127 ) Update finch to 0.12.0 ( https://github.com/mana-ethereum/ethereumex/pull/126 )","ref":"changelog.html#0-10-0-2022-05-10"},{"type":"extras","title":"Changelog - 0.9.2 - 2022-04-01","doc":"Update finch to 0.11 ( https://github.com/mana-ethereum/ethereumex/commit/28fcb106c04cfc26b78cfbc558acc2385a816ebe )","ref":"changelog.html#0-9-2-2022-04-01"},{"type":"extras","title":"Changelog - 0.9.1 - 2022-02-12","doc":"Namespace finch adapter under Ethereumex ( https://github.com/mana-ethereum/ethereumex/pull/113 ) Move application into a separate module ( https://github.com/mana-ethereum/ethereumex/pull/108 ) Add http_headers as optional param ( https://github.com/mana-ethereum/ethereumex/pull/111 )","ref":"changelog.html#0-9-1-2022-02-12"},{"type":"extras","title":"Changelog - 0.9.0 - 2021-12-25","doc":"Allow adding custom headers ( https://github.com/mana-ethereum/ethereumex/pull/97 ) Handle errors in batch requests ( https://github.com/mana-ethereum/ethereumex/pull/98 )","ref":"changelog.html#0-9-0-2021-12-25"},{"type":"extras","title":"Changelog - 0.8.0 - 2021-11-21","doc":"Switch from httpoison to finch ( https://github.com/mana-ethereum/ethereumex/pull/94 )","ref":"changelog.html#0-8-0-2021-11-21"},{"type":"extras","title":"Changelog - 0.7.1 - 2021-10-10","doc":"Change telemetry version ( https://github.com/mana-ethereum/ethereumex/pull/92 )","ref":"changelog.html#0-7-1-2021-10-10"},{"type":"extras","title":"Changelog - 0.7.0 - 2020-12-07","doc":"Remove unremovable default hackney pool ( https://github.com/mana-ethereum/ethereumex/pull/82 ) Change ipc_path to absolute path ( https://github.com/mana-ethereum/ethereumex/pull/87 ) Bump deps ( https://github.com/mana-ethereum/ethereumex/pull/88 ) Config.setup_children can inject client type ( https://github.com/mana-ethereum/ethereumex/pull/83 ) Improve typespecs ( https://github.com/mana-ethereum/ethereumex/pull/80 , https://github.com/mana-ethereum/ethereumex/pull/85 , https://github.com/mana-ethereum/ethereumex/pull/86 )","ref":"changelog.html#0-7-0-2020-12-07"},{"type":"extras","title":"Changelog - 0.6.4 - 2020-07-24","doc":"Fix request id exhaustion due to exponential increment ( https://github.com/mana-ethereum/ethereumex/pull/76 )","ref":"changelog.html#0-6-4-2020-07-24"},{"type":"extras","title":"Changelog - 0.6.3 - 2020-06-30","doc":"Make batch requests support configurable url via opts argument ( https://github.com/mana-ethereum/ethereumex/pull/77 )","ref":"changelog.html#0-6-3-2020-06-30"},{"type":"extras","title":"Changelog - 0.6.2 - 2020-05-27","doc":"Make telemetry required dependency ( https://github.com/mana-ethereum/ethereumex/pull/73 )","ref":"changelog.html#0-6-2-2020-05-27"},{"type":"extras","title":"Changelog - 0.6.1 - 2020-04-16","doc":"Dependency updates: :httpoison 1.4 -&gt; 1.6, :jason 1.1 -&gt; 1.2, :credo 0.10.2 -&gt; 1.3, :ex_doc 0.19 -&gt; 0.21, :dialyxir 1.0.0-rc.7 -&gt; 1.0.0. And small refactors according to Credo. https://github.com/mana-ethereum/ethereumex/pull/69","ref":"changelog.html#0-6-1-2020-04-16"},{"type":"extras","title":"Changelog - 0.6.0 - 2020-03-02","doc":"Deprecate measurements via adapter for :telemetry. https://github.com/mana-ethereum/ethereumex/pull/68","ref":"changelog.html#0-6-0-2020-03-02"},{"type":"extras","title":"Changelog - 0.5.6 - 2020-02-28","doc":"Feature that allows measuring number of RPC calls via an adapter https://github.com/mana-ethereum/ethereumex/pull/67","ref":"changelog.html#0-5-6-2020-02-28"},{"type":"extras","title":"Changelog - 0.5.5 - 2020-10-21","doc":"Allow request counter resetting ( https://github.com/mana-ethereum/ethereumex/pull/65 )","ref":"changelog.html#0-5-5-2020-10-21"},{"type":"extras","title":"Changelog - 0.5.4 - 2020-05-23","doc":"Reported issue with dialyzer specs for boolean arguments in params ( https://github.com/mana-ethereum/ethereumex/pull/61 )","ref":"changelog.html#0-5-4-2020-05-23"},{"type":"extras","title":"Changelog - 0.5.3 - 2019-02-10","doc":"Add special case for empty response ( https://github.com/mana-ethereum/ethereumex/pull/59 )","ref":"changelog.html#0-5-3-2019-02-10"},{"type":"extras","title":"Changelog - 0.5.2 - 2018-12-29","doc":"Fix eth_estimateGas ( https://github.com/mana-ethereum/ethereumex/pull/55 ) Add eth_getProof ( https://github.com/mana-ethereum/ethereumex/pull/57 )","ref":"changelog.html#0-5-2-2018-12-29"},{"type":"extras","title":"Changelog - 0.5.1 - 2018-11-04","doc":"Replaced poison with jason ( https://github.com/mana-ethereum/ethereumex/pull/50 ) Upgraded httpoison to v1.4 ( https://github.com/mana-ethereum/ethereumex/pull/50 )","ref":"changelog.html#0-5-1-2018-11-04"},{"type":"extras","title":"Changelog - 0.5.0 - 2018-10-25","doc":"Remove tunneling requests ( https://github.com/exthereum/ethereumex/pull/46 ) Use poolboy for IpcClient ( https://github.com/exthereum/ethereumex/pull/47 )","ref":"changelog.html#0-5-0-2018-10-25"},{"type":"extras","title":"Changelog - 0.4.0 - 2018-10-27","doc":"Use IPC with IpcClient. Choose client type based on config :client_type ( https://github.com/exthereum/ethereumex/pull/40 ) Update poison, credo, dialyzer ( https://github.com/exthereum/ethereumex/pull/42 )","ref":"changelog.html#0-4-0-2018-10-27"},{"type":"extras","title":"Changelog - 0.3.4 - 2018-09-25","doc":"Allow configuring GenServer timeout for requests ( https://github.com/exthereum/ethereumex/pull/39 )","ref":"changelog.html#0-3-4-2018-09-25"},{"type":"extras","title":"Changelog - 0.3.3 - 2018-07-31","doc":"Added dynamic url input( https://github.com/exthereum/ethereumex/pull/37 )","ref":"changelog.html#0-3-3-2018-07-31"},{"type":"extras","title":"Changelog - 0.3.2 - 2018-03-29","doc":"Fix eth_getLogs mathod params ( https://github.com/exthereum/ethereumex/pull/20 )","ref":"changelog.html#0-3-2-2018-03-29"},{"type":"extras","title":"Changelog - 0.3.1 - 2018-02-09","doc":"Handle failed HTTP requests more gracefully ( https://github.com/exthereum/ethereumex/pull/19 )","ref":"changelog.html#0-3-1-2018-02-09"},{"type":"extras","title":"Changelog - 0.3.0 - 2018-01-23","doc":"Breaking: Use :url config variable instead of :host , :port and :scheme ( https://github.com/exthereum/ethereumex/pull/13 )","ref":"changelog.html#0-3-0-2018-01-23"},{"type":"extras","title":"Changelog - 0.2.0 - 2018-10-16","doc":"Breaking: explicit parameters ( https://github.com/exthereum/ethereumex/pull/10 )","ref":"changelog.html#0-2-0-2018-10-16"},{"type":"extras","title":"Changelog - 0.1.2 - 2017-09-25","doc":"Added generic request method ( https://github.com/exthereum/ethereumex/pull/4 )","ref":"changelog.html#0-1-2-2017-09-25"},{"type":"extras","title":"Changelog - 0.1.1 - 2017-09-16","doc":"Added necessary JSON header for parity ( https://github.com/exthereum/ethereumex/pull/2 )","ref":"changelog.html#0-1-1-2017-09-16"},{"type":"extras","title":"License","doc":"Copyright (c) 2018 Ayrat Badykov Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"Elixir JSON-RPC client for the Ethereum blockchain. Check out the documentation here .","ref":"readme.html"},{"type":"extras","title":"Overview - Installation","doc":"Add :ethereumex to your list of dependencies in mix.exs : def deps do [ { :ethereumex , &quot;~&gt; 0.10&quot; } ] end Ensure :ethereumex is started before your application: def application do [ applications : [ :ethereumex ] ] end","ref":"readme.html#installation"},{"type":"extras","title":"Overview - Configuration","doc":"In config/config.exs , add Ethereum protocol host params to your config file config :ethereumex , url : &quot;http://localhost:8545&quot; You can also configure the HTTP request timeout for requests sent to the Ethereum JSON-RPC (you can also overwrite this configuration in opts used when calling the client). config :ethereumex , http_options : [ pool_timeout : 5000 , receive_timeout : 15_000 ] , http_headers : [ { &quot;Content-Type&quot; , &quot;application/json&quot; } ] :pool_timeout - This timeout is applied when we check out a connection from the pool. Default value is 5_000 . :receive_timeout - The maximum time to wait for a response before returning an error. Default value is 15_000 If you want to use IPC you will need to set a few things in your config. First, specify the :client_type : config :ethereumex , client_type : :ipc This will resolve to :http by default. Second, specify the :ipc_path : config :ethereumex , ipc_path : &quot;/path/to/ipc&quot; If you want to count the number of RPC calls per RPC method or overall, you can attach yourself to executed telemetry events. There are two events you can attach yourself to: [:ethereumex] # has RPC method name in metadata Emitted event: {:event, [:ethereumex], %{counter: 1}, %{method_name: &quot;method_name&quot;}} or more granular [:ethereumex, &lt;rpc_method&gt;] # %{} metadata Emitted event: {:event, [:ethereumex, :method_name_as_atom], %{counter: 1}, %{}} Each event caries a single ticker that you can pass into your counters (like Statix.increment/2 ). Be sure to add :telemetry as project dependency. The IPC client type mode opens a pool of connection workers (default is 5 and 2, respectively). You can configure the pool size. config :ethereumex , ipc_worker_size : 5 , ipc_max_worker_overflow : 2 , ipc_request_timeout : 60_000","ref":"readme.html#configuration"},{"type":"extras","title":"Overview - Test","doc":"Download parity and initialize the password file $ make setup Run parity $ make run Run tests $ make test","ref":"readme.html#test"},{"type":"extras","title":"Overview - Usage","doc":"Available methods: web3_clientVersion web3_sha3 net_version net_peerCount net_listening eth_protocolVersion eth_syncing eth_coinbase eth_mining eth_hashrate eth_gasPrice eth_accounts eth_blockNumber eth_getBalance eth_getStorageAt eth_getTransactionCount eth_getBlockTransactionCountByHash eth_getBlockTransactionCountByNumber eth_getUncleCountByBlockHash eth_getUncleCountByBlockNumber eth_getCode eth_sign eth_sendTransaction eth_sendRawTransaction eth_call eth_estimateGas eth_getBlockByHash eth_getBlockByNumber eth_getTransactionByHash eth_getTransactionByBlockHashAndIndex eth_getTransactionByBlockNumberAndIndex eth_getTransactionReceipt eth_getUncleByBlockHashAndIndex eth_getUncleByBlockNumberAndIndex eth_getCompilers eth_compileLLL eth_compileSolidity eth_compileSerpent eth_newFilter eth_newBlockFilter eth_newPendingTransactionFilter eth_uninstallFilter eth_getFilterChanges eth_getFilterLogs eth_getLogs eth_getProof eth_getWork eth_submitWork eth_submitHashrate db_putString db_getString db_putHex db_getHex shh_post shh_version shh_newIdentity shh_hasIdentity shh_newGroup shh_addToGroup shh_newFilter shh_uninstallFilter shh_getFilterChanges shh_getMessages IpcClient You can follow along with any of these examples using IPC by replacing HttpClient with IpcClient . Examples iex&gt; Ethereumex.HttpClient . web3_client_version { :ok , &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot; } # Using the url option will overwrite the configuration iex&gt; Ethereumex.HttpClient . web3_client_version ( url : &quot;http://localhost:8545&quot; ) { :ok , &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot; } iex&gt; Ethereumex.HttpClient . web3_sha3 ( &quot;wrong_param&quot; ) { :error , %{ &quot;code&quot; =&gt; - 32602 , &quot;message&quot; =&gt; &quot;Invalid params: invalid format.&quot; } } iex&gt; Ethereumex.HttpClient . eth_get_balance ( &quot;0x407d73d8a49eeb85d32cf465507dd71d507100c1&quot; ) { :ok , &quot;0x0&quot; } Note that all method names are snakecases, so, for example, shh_getMessages method has corresponding Ethereumex.HttpClient.shh_get_messages/1 method. Signatures can be found in Ethereumex.Client.Behaviour. There are more examples in tests. eth_call example - Read only smart contract calls In order to call a smart contract using the JSON-RPC interface you need to properly hash the data attribute (this will need to include the contract method signature along with arguments if any). You can do this manually or use a hex package like ABI to parse your smart contract interface or encode individual calls. defp deps do [ ... { :ethereumex , &quot;~&gt; 0.9&quot; } , { :ex_abi , &quot;~&gt; 0.5&quot; } ... ] end Now load the ABI and pass the method signature. Note that the address needs to be converted to bytes: address = &quot;0xF742d4cE7713c54dD701AA9e92101aC42D63F895&quot; |&gt; String . slice ( 2 .. - 1 ) |&gt; Base . decode16! ( case : :mixed ) contract_address = &quot;0xC28980830dD8b9c68a45384f5489ccdAF19D53cC&quot; abi_encoded_data = ABI . encode ( &quot;balanceOf(address)&quot; , [ address ] ) |&gt; Base . encode16 ( case : :lower ) Now you can use eth_call to execute this smart contract command: balance_bytes = Ethereumex.HttpClient . eth_call ( %{ data : &quot;0x&quot; &lt;&gt; abi_encoded_data , to : contract_address } ) To convert the balance into an integer: balance_bytes |&gt; String . slice ( 2 .. - 1 ) |&gt; Base . decode16! ( case : :lower ) |&gt; TypeDecoder . decode_raw ( [ { :uint , 256 } ] ) |&gt; List . first Custom requests Many Ethereum protocol implementations support additional JSON-RPC API methods. To use them, you should call Ethereumex.HttpClient.request/3 method. For example, let's call parity's personal_listAccounts method. iex&gt; Ethereumex.HttpClient . request ( &quot;personal_listAccounts&quot; , [ ] , [ ] ) { :ok , [ &quot;0x71cf0b576a95c347078ec2339303d13024a26910&quot; , &quot;0x7c12323a4fff6df1a25d38319d5692982f48ec2e&quot; ] } Batch requests To send batch requests use Ethereumex.HttpClient.batch_request/1 or Ethereumex.HttpClient.batch_request/2 method. requests = [ { :web3_client_version , [ ] } , { :net_version , [ ] } , { :web3_sha3 , [ &quot;0x68656c6c6f20776f726c64&quot; ] } ] Ethereumex.HttpClient . batch_request ( requests ) { :ok , [ { :ok , &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot; } , { :ok , &quot;42&quot; } , { :ok , &quot;0x47173285a8d7341e5e972fc677286384f802f8ef42a5ec5f03bbfa254cb01fad&quot; } ] }","ref":"readme.html#usage"},{"type":"extras","title":"Overview - Built on Ethereumex","doc":"If you are curious what others are building with ethereumex, you might want to take a look at these projects: exw3 - A high-level contract abstraction and other goodies similar to web3.js eth - Ethereum utilities for Elixir. eth_contract - A set of helper methods for calling ETH Smart Contracts via JSON RPC. ethers - Interacting with EVM contracts like first-class Elixir functions similar to Ethers.js","ref":"readme.html#built-on-ethereumex"},{"type":"extras","title":"Overview - Contributing","doc":"Fork it! Create your feature branch ( git checkout -b my-new-feature ) Commit your changes ( git commit -am 'Add some feature' ) Push to the branch ( git push origin my-new-feature ) Create new Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"Overview - Copyright and License","doc":"Copyright (c) 2018 Ayrat Badykov Released under the MIT License, which can be found in the repository in LICENSE.md .","ref":"readme.html#copyright-and-license"}]